
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>可以在子线程绘画的View  SurfaceView / iVAN</title>

    <meta name="description" content="可以在子线程绘画的View  SurfaceView 转载请注明出处:王亟亟的大牛之路 最近两天都没有写文章,一方面是自己在看书,一方面不知道写什么,本来昨天想写Glide或者RxAndroid的东西结果公司的&quot;狗屎&quot;网怎么都刷不好Gradle我也是无语了(翻墙也没用),准备今天背着笔记本 回家搞,真是服了.. 抱怨的话不说了,来看下这一篇要讲的主角 SurfaceView,关于SurfaceView的文章其实在别的一些站点上也有,因为我之前没写过,所以也就一直没整这部分的内容(别人写的好坏反正找好的点自己吸收吧,嘿嘿) 问题: ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">可以在子线程绘画的View  SurfaceView</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>转载请注明出处：<a href="http://blog.csdn.net/ddwhan0123" rel="external nofollow noreferrer">王亟亟的大牛之路</a></h3>
<p>最近两天都没有写文章，一方面是自己在看书，一方面不知道写什么，本来昨天想写<strong>Glide或者RxAndroid</strong>的东西结果公司的“狗屎”网怎么都刷不好Gradle我也是无语了（翻墙也没用），准备今天背着笔记本 回家搞，真是服了。。</p>
<hr>
<br />抱怨的话不说了，来看下这一篇要讲的主角 <strong>SurfaceView</strong>，关于SurfaceView的文章其实在别的一些站点上也有，因为我之前没写过，所以也就一直没整这部分的内容（别人写的好坏反正找好的点自己吸收吧，嘿嘿）</p>
<p>问题：SurfaceView是什么？</p>
<p>View类的子类</p>
<pre><code>public class SurfaceView extends View</code></pre>
<blockquote><h4>surfaceView是在一个新起的单独线程中可以重新绘制画面而View必须在UI的主线程中更新画面。</h4>
</blockquote>
<p>这点很重要，那我们可以在哪使用它？那些一直在刷的，还会耗性能的一些UI内容我们可以让他去画，毕竟不在主线程（想想渐变这类的东西）</p>
<p>再例举一些使用场景，假设我要画一个视图他和用户有交互，那么用View还是SurfaceView？</p>
<p>像这样的情况就比较推荐用View因为要有Touch事件，用View更合适。而0交互的那些场景用用SurfaceView对性能会有一定的帮助，接下来用例子来具体描述如何用SurfaceView。</p>
<hr>
<br />先上效果图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAzMjIxNjAzNDg5NzI=.jpg"></p>
<p>效果很简单就是在一个Activity里设置了个白色背景，然后写了个“你好”。</p>
<p>来看下代码（一些知识点在标注里说明）</p>
<pre><code>import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;

/**
 * Created by jiajiewang on 16/3/22.
 */

public class CustomView extends SurfaceView implements SurfaceHolder.Callback, View.OnTouchListener {
    private Context context;
    private SurfaceHolder surfaceHolder;
    private CustomThread customThread;

    public CustomView(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.setKeepScreenOn(true);
        this.setFocusable(true);
        //用于触摸事件
        this.setLongClickable(true);
        this.context = context;
        //获取对象实例
        surfaceHolder = this.getHolder();
        // 给SurfaceView添加回调
        surfaceHolder.addCallback(this);
        //创建工作线程
        customThread = new CustomThread(surfaceHolder);

    }

    //创建的时候调用
    @Override
    public void surfaceCreated(SurfaceHolder holder) {
        customThread.canRun = true;
        //工作线程开始工作
        customThread.start();
        Log.d("--&gt;surfaceCreated", "surfaceCreated");
    }

    //发生改变的时候调用
    @Override
    public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {

        Log.d("--&gt;surfaceChanged", "surfaceChanged");
    }

    //销毁时的时候调用
    @Override
    public void surfaceDestroyed(SurfaceHolder holder) {

        customThread.canRun = false;
        Log.d("--&gt;surfaceDestroyed", "surfaceDestroyed");

    }

    @Override
    public boolean onTouch(View v, MotionEvent event) {
        switch (event.getAction()) {

            case MotionEvent.ACTION_DOWN:

                Log.d("MotionEvent", "ACTION_DOWN");

                break;

            case MotionEvent.ACTION_UP:

                Log.d("MotionEvent", "ACTION_UP");

                break;

            case MotionEvent.ACTION_MOVE:

                Log.d("MotionEvent", "ACTION_MOVE");

                break;

        }

        return super.onTouchEvent(event);

    }
}

//工作线程
class CustomThread extends Thread {
    private SurfaceHolder surfaceHolder;
    public boolean canRun;

    public CustomThread(SurfaceHolder surfaceHolder) {
        this.surfaceHolder = surfaceHolder;
        canRun = true;
    }

    @Override
    public void run() {

        while (canRun) {
            Canvas canvas = null;
            //线程同步
            synchronized (surfaceHolder) {
                //创建画笔
                Paint paint = new Paint();
                paint.setColor(Color.GREEN);
                paint.setTextSize(200);
                // 锁定画布(想一下,类似Bitmap的效果)
                canvas = surfaceHolder.lockCanvas();
                //画背景
                canvas.drawColor(Color.WHITE);
                //画字
                canvas.drawText("妈蛋", 100, 300, paint);
            }

            if (canvas != null) {
                // 结束锁定
                surfaceHolder.unlockCanvasAndPost(canvas);
            }

        }

    }

</code></pre>
<p>流程：</p>
<p>这是一个自定义的SurfaceView并实现了SurfaceHolder.Callback</p>
<p>在这个自定义SurfaceView被创建的时候去开启工作线程去做了该做的事，MainActivity没做任何事也就是 加载一下，还是在XML里引入的。</p>
<pre><code>  &lt;sample.wjj.surfaceviewdemo.CustomView
      android:layout_width="wrap_content"
      android:layout_height="wrap_content" /&gt;</code></pre>
<p>那我们来看下 SurfaceView一些比较重要的（常用的）方法。</p>
<blockquote><p>getHolder()  获取SurfaceHolder对象，Surface 就在SurfaceHolder对象内</p>
<p>Canvas lockCanvas()或则Canvas lockCanvas(Rect dirty) 获取Canvas对象</p>
<p>unlockCanvasAndPost(Canvas canvas) 函数会释放该锁，用于操作UI</p></blockquote>
<p>在调用lockCanvas函数获取Canvas后，SurfaceView会获取Surface的一个同步锁直到调用unlockCanvasAndPost(Canvas canvas)函数才释放该锁，这里的同步机制保证在Surface绘制过程中不会被改变（被摧毁、修改）。</p>
<p>再说一下绘制的类型（更好的运用性能）</p>
<pre><code>SURFACE_TYPE_NORMAL：用RAM缓存原生数据的普通Surface 

SURFACE_TYPE_HARDWARE：适用于DMA(Direct memory access )引擎和硬件加速的Surface 

SURFACE_TYPE_GPU：适用于GPU加速的Surface 

SURFACE_TYPE_PUSH_BUFFERS：表明该Surface不包含原生数据，Surface用到的数据由其他对象提供，在Camera图像预览中就使用该类型的Surface，有Camera负责提供给预览Surface数据，这样图像预览会比较流畅。如果设置这种类型则就不能调用lockCanvas来获取Canvas对象了。
</code></pre>
<p>因为没有什么其他第三方资源所以就不存源码了。</p>
<p>如果在学习的过程中有什么问题或者项目中有什么问题需要找人探讨的可以扫以下微信和我沟通（私人微信都不是什么平台的会相对回的比较快，骚扰的别来，坏人烂JJ！！） <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjAzMjIxNjM2MjQ3OTU=.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-29 04:43:08</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>可以在子线程绘画的View  SurfaceView的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3oKXkb.html" rel="bookmark">【黑马Android】&lpar;05&rpar;短信&sol;查询和添加&sol;内容观察者使用&sol;子线程网络图片查看器和Handler消息处理器&sol;html查看器&sol;使用HttpURLConnection采用Post方式请求数据&sol;开源项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				备份短信和添加短信 操作系统短信的uri: content://sms/ &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt; &lt;manifest xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot; package=&quot;com.itheima28.backupsms&quot; android:versionCode=&quot;1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQRZdp.html" rel="bookmark">OkHttp3几个简单的例子和在子线程更新UI线程的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				okHttp用于android的http请求.据说很厉害,我们来一起尝尝鲜.但是使用okHttp也会有一些小坑,后面会讲到如何掉进坑里并爬出来. 首先需要了解一点,这里说的UI线程和主线程是一回事儿.就是唯一可以更新UI的线程.这个只是点会在给okHttp填坑的时候用到.而且,这个内容本身在日常的开发中也经常用到,值得好好学一学. okHttp发起同步请求 第一个列子是一个同步请求的例子. private void performSyncHttpRequest() { OkHttpClient			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWDR1rp.html" rel="bookmark">详解Android中OkHttp3的例子和在子线程更新UI线程的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				okHttp用于android的http请求.据说很厉害,我们来一起尝尝鲜.但是使用okHttp也会有一些小坑,后面会讲到如何掉进坑里并爬出来. 首先需要了解一点,这里说的UI线程和主线程是一回事儿.就是唯一可以更新UI的线程.这个只是点会在给okHttp填坑的时候用到.而且,这个内容本身在日常的开发中也经常用到,值得好好学一学. okHttp发起同步请求 第一个列子是一个同步请求的例子. private void performSyncHttpRequest() { OkHttpClient			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOn88p.html" rel="bookmark">Android任意时刻从子线程切换到主线程的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引入 在Android开发中常常会遇到网络请求,数据库数据准备等一些耗时的操作:而这些操作是不允许在主线程中进行的.因为这样会堵塞主线程导致程序出现未响应情况. 所以只能另起一个子线程进行这些耗时的操作,完成后再显示到界面.众所周知,界面等控件操作只能在主线程中完成:所以不可避免的需要从子线程切换到主线程. 方法 对于这样的情况在Android 中比较常见的是使用AsynTask类或者 Handler来进行线程切换:而其中AsynTask是官方封装的类,较为简单,效率也比较可以,但是并不适合所有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWX92Gp.html" rel="bookmark">子程序建立socket崩溃-安卓下建立socket就崩溃，分到子线程仍然不行，求助啊</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 安卓下建立socket就崩溃,分到子线程仍然不行,求助啊 原代码如下,如果我不用BUTTON去触发的话是可以建立SOCKET的,但是用上BUTTON,把建立SOCKET的方法放到子线程中,仍然exception会显示不能再主线程中使用网络操作,真心求解为什么,看了2天了,刚学JAVA,不太理解. package com.example.xlguang.wifi; import android.os.Bundle; import android.os.Handler; import an			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZEoJqp.html" rel="bookmark">编程-安卓，主线程和子线程间传递消息，出错&CenterDot;，求大家帮我看看</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 安卓,主线程和子线程间传递消息,出错·,求大家帮我看看 我的代码如下: activitymain.xml: xmlns:tools=&quot;&quot;http://schemas.android.com/tools&quot;&quot; android:layout_width=&quot;&quot;match_parent&quot;&quot; android:layout_height=&quot;&quot;match_parent&quot;&quot; android:pa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdE1v6z.html" rel="bookmark">Android--Handler的使用方法：在子线程中更新界面</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要介绍Android的Handler的使用方法.Handler可以发送Messsage和Runnable对象到与其相关联的线程的消息队列.每个Handler对象与创建它的线程相关联,并且每个Handler对象只能与一个线程相关联.     Handler一般有两种用途:1)执行计划任务,你可以再预定的实现执行某些任务,可以模拟定时器.2)线程间通信.在Android的应用启动时,会创建一个主线程,主线程会创建一个消息队列来处理各种消息.当你创建子线程时,你可以再你的子线程中拿到父线程中创建			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQr5aoM.html" rel="bookmark">Android实现在子线程中更新Activity中UI的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android实现在子线程中更新Activity中UI的方法.分享给大家供大家参考,具体如下: 在Android平台下,进行多线程编程时,经常需要在主线程之外的一个单独的线程中进行某些处理,然后更新用户界面显示.但是,在主线线程之外的线程中直接更新页面显示的问题是:系统会报这个异常: ERROR/AndroidRuntime(1222): android.view.ViewRoot$CalledFromWrongThreadException: Only the original			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6N8kWM.html" rel="bookmark">安卓，子线程获取网络图片，发消息给主线程，主线程用图片填充listview，出错</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 安卓,子线程获取网络图片,发消息给主线程,主线程用图片填充listview,出错 先上logcat: 我的xml布局就是一个按钮,和一个listview,listview里就一个imageview,按下按钮开始从网络获取图片,然后发消息到主线程,然后listview就填充数据.xml代码就不贴了. 以下是mainactivity public class MainActivity extends AppCompatActivity implements View.OnClickList			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqnrRp.html" rel="bookmark" class="title">设计如何量化 应该为设计支付多少钱？</a>
					<div>
						文章描述:应该为设计支付多少钱?设计圈一直也有讨论设计如何量化的问题. 谈钱伤感情,谈感情伤钱. 过去两周里,我在北京西边的两个咖啡馆混饭吃,自己没有掏一分钱.少一半是熟人,多一半是完全陌生的&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boQmDp.html" rel="bookmark" class="title">爱情香烟：百度对网站排名机制分析</a>
					<div>
						对于百度的排名机制,相信学习过简单的seo优化技巧的人都会明白一二,今天我就谈谈百度对于网民点击进行排名的机制. 可以说是防作弊机制吧. 有部分站长,刷排名,利用seo优化软件. 就是在百度搜索结果里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwvxRp.html" rel="bookmark" class="title">用&OpenCurlyDoubleQuote;心&amp;amp&semi;quot&semi;解决网站降权问题</a>
					<div>
						网站被降权这个另无数站长头痛而又无奈,可谓&quot;辛辛苦苦几十年,一下回到解放前.&quot;这种滋味真的不是我们个人站长能够承受的起的.但是话说回来,&quot;道高一尺,魔高一丈.&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnO6mz.html" rel="bookmark" class="title">Photoshop真实云彩文字的制作</a>
					<div>
						教程中我会向大家展示如何创建云彩文字,要使用到笔刷和其他一些有趣的灯光效果.步揍不多,但是有些地方需要很耐心的处理. 最终效果    步骤1    在Photoshop中创建一个新文件 ,我用的是19 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAVxBb.html" rel="bookmark" class="title">excel单元格锁定</a>
					<div>
						excel是常用的数据处理软件,通常办公必备人员都会用到它.经常办公的时候需要对一些数据或者模板需要被保护,怕工作人员不小心删除一些重要的数据.这样的话就必须将需要保护的单元格数据进行锁定了.那么小编 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlv7db.html" rel="bookmark" class="title">photoshop精美壁纸制作教程</a>
					<div>
						最终效果 1.新建一个1024 * 768 像素问你,选择渐变工具,颜色设置如图1,拉出图2所示的线性渐变. &lt;图1&gt; &lt;图2&gt; 2.新建一个图层,用椭圆选框工具拉一个图3所示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywwLEz.html" rel="bookmark" class="title">PHP判断远程图片是否存在的几种方法</a>
					<div>
						  这篇文章主要介绍了PHP判断远程图片是否存在的几种方法,需要的朋友可以参考下 在做一个图片预览中图的东西,遇到一个问题,就是要判断远程文件是否存在(不是同一台服务器). 代码如下: 代码如下: / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42XDqM.html" rel="bookmark" class="title">win7系统开机出现蓝屏代码0x00000f4怎么解决</a>
					<div>
						  蓝屏故障图: 原因分析:蓝屏代码0x00000F4可能是硬件出现了故障,一般可能是故障的硬盘或者内存导致的的,不过也不能肯定,有时候有少数是其他原因导致的,建议用下面几个步骤去排除并解决问题. 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRPL5p.html" rel="bookmark" class="title">详解WordPress开发中get&lowbar;header&lpar;&rpar;获取头部函数的用法&lowbar;php技巧</a>
					<div>
						函数意义详解从当前主题调用header.php文件.是不是很简单?好吧,如果你是新手的话这里要提醒一下,这里的get和get_children().get_category中的get略有不同之处. g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6KZqz.html" rel="bookmark" class="title">五大策略助你完美备份数据</a>
					<div>
						    每年你都说最好是把数据进行备份,但生活往往会发生变化.你开始忙起来,为各种事分心.你的数字生活中的文件数量成指数增长--纷繁的事情让你把这件重要任务继续推到&quot;我会处理的&quot;这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZYW9b.html" rel="bookmark" class="title">求帮忙-计算机程序可以单独存在吗？</a>
					<div>
						问题描述 计算机程序可以单独存在吗? 计算机程序可以单独存在吗?它必须要依赖什么东西?计算机程序可以单独存在吗?它必须要依赖什么东西?计算机程序可以单独存在吗?它必须要依赖什么东西?计算机程序可以单独 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNaDkz.html" rel="bookmark" class="title">浅谈动态库符号的私有化与全局化</a>
					<div>
						之前一篇&lt;记一个链接库导出函数被覆盖的问题&gt;中,描述了这样一个问题:动态库若想使用自己的符号,不受可执行程序(或其他动态库的影响),可以使用-Wl,-Bsymbolic链接参数或versi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBw2WM.html" rel="bookmark" class="title">请教一个复杂的sql问题</a>
					<div>
						问题描述 我有个表,里面有个字段叫content,现在有6个关键词(限行,道路,交警,设卡,指挥,拥堵),我想查content中包含其中任意两个关键词的记录. 问题补充:有没有用一条sql语句解决的方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB1krb.html" rel="bookmark" class="title">美国公认顶尖黑客榜</a>
					<div>
						姓名:理查德.斯托曼(Richard Stallman) 个人网址: http://www.undergrad.math.uwaterloo.ca/agray/meme.html 简历:他从1971年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4NmPz.html" rel="bookmark" class="title">Office 365 - SharePoint 2013 Online 中创建母版页</a>
					<div>
						1.登陆SharePoint Online站点,点击右上角的设置按钮,如下图: 2.点击进入网站设置,到下面两个地方开启SharePoint Server 发布基础架构: 网站集管理 – 网站集功能  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Zqnap.html" rel="bookmark" class="title">SQL数据库的终结&quest;</a>
					<div>
						第一部分 SQL 的发展起始于 E.F.Codd 博士1970年六月发表于计算机协会的&quot;通信&quot;上的一篇论文, &quot;大型共享数据库的关系模型&quot;.当时他和他的在IBM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Zeerp.html" rel="bookmark" class="title">拥抱Hadoop领跑大数据 实现价值回报</a>
					<div>
						本文讲的是拥抱Hadoop领跑大数据 实现价值回报,当大数据风暴来临的时候,你是否已经做好准备?2012年对于企业来讲最为企业CIO所关心的话题之一必然要属于大数据.我们看到无论是个人还是企业,随着互 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnrK8M.html" rel="bookmark" class="title">钢材，可以进行网上交易吗&quest;完全可以！</a>
					<div>
						钢材,可以进行网上交易吗?完全可以.有一家网站正在做这样的事情:上游帮助钢厂和大型钢铁贸易商卖货,下游帮钢铁求购商免费发布求购信息.这家企业的名字叫&quot;找钢网&quot;:交易型B2B平台;帮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2293rb.html" rel="bookmark" class="title">MSN&OpenCurlyDoubleQuote;脱机症&rdquo;今日消失</a>
					<div>
						微软方面否认受黑客攻击 只是技术问题 本报讯(记者杨帆)自去年7月和12月MSN两次出现大面积掉线现象后,昨日上午开始,MSN再次陷入技术故障,部分用户明明已经登录,好友却无法看到自己在线,显示状态为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqNZyb.html" rel="bookmark" class="title">c&num;-dll需要用到的外部文件</a>
					<div>
						问题描述 dll需要用到的外部文件 请问下: 我准备用C#写一个算法,封装成dll.但算法需要读取一个Excel文件里面的数据, 请问下如何做到最后生成的dll文件不需要那个Excel文件就可以使用? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgw6DAM.html" rel="bookmark" class="title">《Cisco ASA设备使用指南》一第1章　安全技术介绍</a>
					<div>
						第1章 安全技术介绍 Cisco ASA设备使用指南 本章涵盖的内容有: 防火墙 入侵检测系统(IDS)与入侵防御系统(IPS) 虚拟专用网络 在过去几年中,各企业.院校和政府机关出现了越来越多的计算 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22NxBb.html" rel="bookmark" class="title">分析网站赚不到钱的四大原因</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 一.不知道如何赚钱 错误思路:等做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoJeNM.html" rel="bookmark" class="title">有了人工智能加持，客户服务质检将是什么样？</a>
					<div>
						随着互联网信息技术在金融领域的应用程度越来越深,各企业在创新力度上的不断加强,市场竞争也在变得越来越激烈,在这种激烈的市场竞争中,客户服务已经越来越成为体现竞争差异.提升公司形象.增加客户满意度的重要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLJWDM.html" rel="bookmark" class="title">大项目仍是睡狮，第三产业撑起广东半边天</a>
					<div>
						上半年广东GDP与国家同为7.1%,但对比一.二两个季度,广东GDP环比增长2.5%,明显高于国家1.8%的增速,广东整体经济积极态势初显. 从产业结构来看,上半年,广东一.二.三产业增加值分别增长4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2WKqz.html" rel="bookmark" class="title">易诺仪器盛装亮相2014CCBN展会</a>
					<div>
						第二十二届中国国际广播电视信息网络展览会(CCBN)于2014年3月20 -22日在北京成功举办.本次展会由国家广播电影电视总局主办,并获得中华人民共和国工业和信息文化部的大力支持.易诺仪器携多款专业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYjerb.html" rel="bookmark" class="title">Android实现扩展Menu的方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android实现扩展Menu的方法.分享给大家供大家参考.具体如下: 1. java代码: package com.tabmenu; import android.content.Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QlQ4M.html" rel="bookmark" class="title">Lua中的变量类型与语句学习总结&lowbar;Lua</a>
					<div>
						1. Lua类型 1.1 基本类型 Lua是一种动态类型语言,没有类型定义的语法.Lua一共有8种基础类型:nil(空).boolean(布尔).number(数字).string(字符串).user ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baq6lQb.html" rel="bookmark" class="title">手机回拨卡长途话费省半：利用话费差价赚钱</a>
					<div>
						现在网消息 一度在网络上&quot;活跃&quot;的手机回拨卡正在江城顶风销售.日前,有消息称,回拨卡的网上热销渠道淘宝宣布将对此实施禁售.但这种钻地区收费差空子的回拨卡,由于价格低廉在江城热销,深 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJedO2p.html" rel="bookmark" class="title">80后的陌陌上市了90后的碰碰融资了</a>
					<div>
						相信很多朋友还记得,媒体在5个月前曾报道游戏化交友产品&quot;碰碰&quot;在上线前获得400多万美元A轮投资,时至今日,该产品全球用户数已破600万,其中并非单纯只有中国的用户粉丝,比如在马来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZm41Bp.html" rel="bookmark" class="title">IBM Tivoli Storage Manager安装指南</a>
					<div>
						IBM http://www.aliyun.com/zixun/aggregation/13966.html&quot;&gt;Tivoli Storage Manager依靠存储备份以及离线存储的数 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
